MODULE DemoHrc;

FROM Graf0Hrc IMPORT InitialisiereGrafik,  Punkt,
                     GrafikEin,GrafikAus,   AspectRatio,
                     SPALTEN,ZEILEN,WEISS,SCHWARZ,FARBEN,
                     BildschirmLoeschen,HorLinie,VertLinie,
                     SchreibeZeichen,SchreibeString,
                     SEITE,SEITE1,SEITE2,AktiveSeite,
                     SichtbareSeite,SeiteKopieren,
                     SeiteLoeschen,PunktInvertieren;

FROM GrafLib0 IMPORT Rahmen, Linie, Kreis;

FROM TermIO   IMPORT Read;

FROM MathLib0 IMPORT sin;

VAR A,B:CARDINAL;

CONST OffOben   = 14;
      Pi        = 3.142;

PROCEDURE WeiterMitTaste;
VAR c : CHAR;
BEGIN
  SchreibeString('Weiter mit beliebiger Taste',50,1,WEISS);
  Read(c)
END WeiterMitTaste;


PROCEDURE RahmenDemo;
BEGIN
    Rahmen(0,OffOben,SPALTEN-1,ZEILEN-1,WEISS);
    SchreibeString(
      'Demo fr Hercules - HorLinie/VertLinie/Rahmen',
       1,1,WEISS);
    FOR B:= 1 TO FARBEN*3 DO
      FOR A:= 1 TO 50 DO
          Rahmen(SPALTEN DIV 2-A*6,ZEILEN DIV 2-3*A,
                 SPALTEN DIV 2+A*6,ZEILEN DIV 2+3*A,
                 (B-FARBEN+1) MOD 2);
      END;
    END;
    WeiterMitTaste;
    BildschirmLoeschen;
END RahmenDemo;

PROCEDURE LinienDemo;
CONST xc = 200;
      yc = 70;
VAR ii : CARDINAL;
BEGIN
  Rahmen(0,OffOben,SPALTEN-1,ZEILEN-1,WEISS);
  SchreibeString('Demo fr Hercules - Linien',
                 1,1,WEISS);
  ii := OffOben;
  REPEAT
    Linie( xc, yc,  0, ii, WEISS);
    Linie(SPALTEN-1, ii, xc, yc, WEISS);
    INC(ii,9);
  UNTIL ii >= ZEILEN;
  ii := 0;
  REPEAT
    Linie(  ii, ZEILEN-1, xc, yc, WEISS);
    Linie( ii,  OffOben, xc,  yc, WEISS);
    INC( ii, 12);
  UNTIL ii >= SPALTEN;
  WeiterMitTaste;
  BildschirmLoeschen;
END LinienDemo;

PROCEDURE EllipsenDemo;
VAR i : CARDINAL;
BEGIN
  Rahmen(0,OffOben,SPALTEN-1,ZEILEN-1,WEISS);
  SchreibeString('Demo fr Hercules - Ellipsen/Kreise',
                 1,1,WEISS);
  FOR i := 1 TO TRUNC(
                 FLOAT((ZEILEN-OffOben) DIV 2)/AspectRatio)
                                                    BY 8 DO
    Kreis(SPALTEN DIV 2, (ZEILEN+OffOben) DIV 2, i, WEISS);
  END;
  WeiterMitTaste;
  BildschirmLoeschen;
END EllipsenDemo;

PROCEDURE SeiteAnzeigen(X,Y:CARDINAL);
BEGIN
    SchreibeString(' Dies ist Seite ',X,Y,SCHWARZ);
    IF SEITE = SEITE1 THEN
         SchreibeString('1 ', X+16,Y,SCHWARZ)
    ELSE SchreibeString('2 ', X+16,Y,SCHWARZ)
    END
END SeiteAnzeigen;

PROCEDURE SeitenDemo;
BEGIN
    AktiveSeite(SEITE2);
    BildschirmLoeschen;
    Rahmen(0,OffOben,SPALTEN-1,ZEILEN-1,WEISS);
    SchreibeString('Demo fr Hercules - Seite 1 / Seite 2',
                   1,1,WEISS);
    SeiteKopieren(SEITE1,SEITE2);    SeiteAnzeigen(15,6);
    AktiveSeite(SEITE1);             SeiteAnzeigen(55,17);
    WeiterMitTaste;
    SichtbareSeite(SEITE2);          WeiterMitTaste;
    SichtbareSeite(SEITE1);          WeiterMitTaste;
    BildschirmLoeschen;
END SeitenDemo;

PROCEDURE PunktDemo;
CONST XOff  = 50;
      SPOff = SPALTEN - 2*XOff;
      dC    = 0.03;
      fact  = 0.9;
VAR   C     : REAL;
BEGIN
    Rahmen(0,OffOben,SPALTEN-1,ZEILEN-1,WEISS);
    SchreibeString('Demo fr Hercules - Punktroutinen',
                   1,1,WEISS);
    SchreibeString(' f(x) = sin x ',55,17,SCHWARZ);
    SchreibeString(' g(x) =   x  ',55,19,SCHWARZ);
    HorLinie(XOff,SPALTEN-XOff,(ZEILEN+OffOben) DIV 2,
             WEISS);
    VertLinie(SPALTEN DIV 2,OffOben*2,ZEILEN-OffOben,
              WEISS);
    C := -Pi;
    REPEAT
      PunktInvertieren(
       TRUNC(FLOAT(SPALTEN DIV 2)+C*FLOAT(SPOff DIV 2)/Pi),
       TRUNC(FLOAT((ZEILEN+OffOben) DIV 2)
               -sin(C)*fact*FLOAT((ZEILEN-OffOben) DIV 2)));
      Punkt(
       TRUNC(FLOAT(SPALTEN DIV 2)+C*FLOAT(SPOff DIV 2)/Pi),
       TRUNC(FLOAT((ZEILEN+OffOben) DIV 2)
               -C*C*0.1*fact*FLOAT((ZEILEN-OffOben) DIV 2)),
               WEISS);
      C := C + dC;
    UNTIL ( C > Pi );
    WeiterMitTaste;
END PunktDemo;


BEGIN
    InitialisiereGrafik;
    GrafikEin;
    SichtbareSeite(SEITE1);
    AktiveSeite(SEITE1);
    RahmenDemo;
    LinienDemo;
    EllipsenDemo;
    SeitenDemo;
    PunktDemo;
    SeiteLoeschen(SEITE1);
    GrafikAus;
END DemoHrc.
