(* ------------------------------------------------------ *)
(*                    GRAF0CGA.MOD                        *)
(*               Grafikbibliothek fr CGA                 *)
(*        (c) 1990  H.Zinner, G.Clarici & TOOLBOX         *)
(* ------------------------------------------------------ *)
IMPLEMENTATION MODULE Graf0CGA;

FROM SYSTEM  IMPORT ASSEMBLER;
FROM Strings IMPORT Length;

  PROCEDURE GrafikEin;
  BEGIN
    ASM
      MOV AX,0006H
      INT 10H
    END;
  END GrafikEin;

  PROCEDURE GrafikAus;
  BEGIN
    ASM
      MOV AX,0003H
      INT 10H
    END;
  END GrafikAus;

  PROCEDURE BildschirmLoeschen;
  BEGIN
    ASM
      PUSH ES
      MOV  AX,0B800H
      MOV  ES,AX
      MOV  CX,04000H
      XOR  DI,DI
      MOV  AX,DI
      REPZ STOSW
      POP ES
    END;
  END BildschirmLoeschen;

  PROCEDURE Punkt(X, Y, Farbe:CARDINAL);
  BEGIN
    ASM
      MOV AX,Farbe
      MOV AH,12
      MOV DX,Y
      MOV CX,X
      INT 10H
    END;
  END Punkt;

  PROCEDURE PunktInvertieren(X, Y:CARDINAL);
  BEGIN
    ASM
      MOV AH,13
      MOV CX,X
      MOV DX,Y
      INT 10H
      NOT AL
      AND AL,0FH
      MOV AH,12
      MOV CX,X
      MOV DX,Y
      INT 10H
    END;
  END PunktInvertieren;

  PROCEDURE PunktTest(X, Y : CARDINAL) : CARDINAL;
  VAR
    ergebnis : CARDINAL;
  BEGIN
    ASM
      MOV AH,13
      MOV CX,X
      MOV DX,Y
      INT 10H
      XOR AH,AH
      MOV ergebnis,AX
    END;
    RETURN ergebnis;
  END PunktTest;

  PROCEDURE SchreibeZeichen(Zeichen    : CHAR;
                            XPosition,
                            YPosition,
                            Farbe      : CARDINAL);
  BEGIN
    ASM
      MOV DX,XPosition
      DEC DX
      MOV BX,YPosition
      DEC BX
      MOV DH,BL
      XOR BH,BH
      MOV AH,2
      INT 10H
      MOV AH,09H
      MOV BX,Farbe
      XOR BH,BH
      XOR CX,CX
      INC CX
      MOV AL,Zeichen
      INT 10H
    END;
  END SchreibeZeichen;

  PROCEDURE SchreibeString(String     : ARRAY OF CHAR;
                           XPosition,
                           YPosition,
                           Farbe      : CARDINAL);
  VAR
    i : CARDINAL;
  BEGIN
    i := 0;
    WHILE i < Length(String) DO
      SchreibeZeichen(String[i], XPosition+i,
                                 YPosition, Farbe);
      i := i + 1;
    END;
  END SchreibeString;

  PROCEDURE VertLinie(X1, Y1, Y2, Farbe : CARDINAL);
  VAR
    y : CARDINAL;
  BEGIN
    FOR y := Y1 TO Y2 DO
      Punkt(X1, y, Farbe);
    END;
  END VertLinie;

  PROCEDURE HorLinie(X1, X2, Y1, Farbe : CARDINAL);
  VAR
    x : CARDINAL;
  BEGIN
    FOR x := X1 TO X2 DO
      Punkt(x, Y1, Farbe);
    END;
  END HorLinie;

END Graf0CGA.
(* ------------------------------------------------------ *)
(*                 Ende von GRAF0CGA.MOD                  *)
